From a593262fc86d3eaee639d54ba7273aedc135edbe Mon Sep 17 00:00:00 2001
From: Sebastian Pop <spop@amazon.com>
Date: Tue, 3 Aug 2021 12:29:02 +0000
Subject: [PATCH] [arm64] port planecopy_cp

          planecopy_cp	36.88x 	 382.57   	 14108.35
---
 source/common/aarch64/asm-primitives.cpp |  3 ++
 source/common/aarch64/pixel-util.S       | 46 ++++++++++++++++++++++++
 2 files changed, 49 insertions(+)

diff --git a/source/common/aarch64/asm-primitives.cpp b/source/common/aarch64/asm-primitives.cpp
index 3767290..451c8b8 100644
--- a/source/common/aarch64/asm-primitives.cpp
+++ b/source/common/aarch64/asm-primitives.cpp
@@ -256,6 +256,9 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
         p.pu[LUMA_64x48].pixelavg_pp[ALIGNED] = PFX(pixel_avg_pp_64x48_neon);
         p.pu[LUMA_64x64].pixelavg_pp[ALIGNED] = PFX(pixel_avg_pp_64x64_neon);
 
+        // planecopy
+        p.planecopy_cp = PFX(pixel_planecopy_cp_neon);
+
         // quant
         p.quant = PFX(quant_neon);
 
diff --git a/source/common/aarch64/pixel-util.S b/source/common/aarch64/pixel-util.S
index 429d89f..b7d1cf4 100644
--- a/source/common/aarch64/pixel-util.S
+++ b/source/common/aarch64/pixel-util.S
@@ -587,6 +587,52 @@ function x265_scale2D_64to32_neon
     ret
 endfunc
 
+// void planecopy_cp_c(const uint8_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int width, int height, int shift)
+function x265_pixel_planecopy_cp_neon
+    dup             v2.16b, w6
+    sub             x5, x5, #1
+
+.loop_h:
+    mov             x6, x0
+    mov             x12, x2
+    mov             x7, #0
+.loop_w:
+    ld1             {v0.16b}, [x6], #16
+    ushl            v0.16b, v0.16b, v2.16b
+    st1             {v0.16b}, [x12], #16
+
+    add             x7, x7, #16
+    cmp             x7, x4
+    blt             .loop_w
+
+    add             x0, x0, x1
+    add             x2, x2, x3
+
+    sub             x5, x5, #1
+    cbnz            x5, .loop_h
+
+// handle last row
+    mov             x5, x4
+    lsr             x5, x5, #3
+
+.loopW8:
+    ld1             {v0.8b}, [x0], #8
+    ushl            v0.8b, v0.8b, v2.8b
+    st1             {v0.8b}, [x2], #8
+    sub             x4, x4, #8
+    sub             x5, x5, #1
+    cbnz            x5, .loopW8
+
+    mov             x5, #8
+    sub             x5, x5, x4
+    sub             x0, x0, x5
+    sub             x2, x2, x5
+    ld1             {v0.8b}, [x0]
+    ushl            v0.8b, v0.8b, v2.8b
+    st1             {v0.8b}, [x2]
+    ret
+endfunc
+
 .macro x265_satd_4x8_8x4_end_neon
     add             v0.8h, v4.8h, v6.8h
     add             v1.8h, v5.8h, v7.8h
-- 
2.25.1

